# Filters added to this controller will be run for all controllers in the application.
# Likewise, all the methods added will be available for all controllers.
class ApplicationController < ActionController::Base
    layout "base",  :except => ["menu", "login", "doLogin", "todoList", "calendar"]
    
    
    before_filter :authorize, :except => ["login", "error", "doLogin"]
    before_filter :permitions, :except => ["login", "error", "doLogin", "logout"]
    
    def rescue_404
        rescue_action_in_public ActiveRecord::RecordNotFound
    end
    
    def rescue_action_in_public(exception)
        case exception
        when ActiveRecord::RecordNotFound
            @message = "Couldn't find  the data"
            render :template => "main/error", :layout => "nologin", :status => "404"
        when ::ActionController::UnknownAction then
            
            @message = "Couldn't find the page"
            render :template => "main/error", :layout => "noloin", :status => "404"
        else
            @message = exception
            render :template => "main/error", :layout => "nologin", :status => "500"
        end
    end
    
    def local_request?
        return false
    end
    
    
    def authorize
        puts "authorize"
        return true if session['user']
        flash[:error] = "Password required! Please log in!"
        redirect_to :controller => "main", :action => "login"
    end
  
    def permitions
        if session['user'].nil?
            return
        end
       
        @permition = Permition.find(:all, :conditions => ["controller = ? and action = ? and group_id = ?", @params[:controller], @params[:action],  session['user'].group.name])
        if @permition.empty?
            @permition = Permition.find(:all, :conditions => ["controller = ? and action = ? and group_id = '*'", @params[:controller], @params[:action]])
            if @permition.empty?
                @permition = Permition.find(:all, :conditions => ["controller = ? and action = '*' and group_id = '*'", @params[:controller]])
            end
        end
        
        if @permition.empty?
            @message = "You have no permitions"
            render :template => "main/error", :layout => "nologin", :status => "404"
        else
            puts "----> #{@params[:controller]} #{@params[:action]} #{@permition[0].readonly}"
            @params = @params.merge({:readonly => @permition[0].readonly})
        end
    end
    
    
   
end