require 'application'
require 'document_helper'

class MissingFile < ActionController::ActionControllerError #:nodoc:
end

class DocumentController < ApplicationController
  include DocumentHelper


    def download
        @doc = Document.find(@params["id"])
        puts "@doc.path = #{@doc.path}"
        
        str = @doc.file_name;
        index = str.rindex(/[\.\s+]/)
        str[index]="_v#{@doc.version}."
        
        begin
            path = find_file(str, @doc.path)
            puts "path = #{path}"
            send_file path
        rescue MissingFile => e
            flash['error'] = "Download error: #{e}" 
            redirect_to :action => 'list'
        end
    end
    
   
    def list
      puts "begin docment list: #{@params} #{@options}"
      puts "obj_type = #{defined? @options['obj_type']}"
      if @params[:id] != nil && @params[:id] != ""
        puts "we are here @params[:id] = #{@params[:id]}"
        @lastVersion = Document.find(@params[:id])
        @docs = Document.find(:all, :conditions => ["obj_type=? and obj_id=? and file_name=?", 
                                                    @lastVersion.obj_type, @lastVersion.obj_id, 
                                                    @lastVersion.file_name], :order => "version desc")
        @params[:show_upload] = false
      else
        sort = case @params['column']
               when "file_name"  then "file_name #{@params['order']}"
  #             when "version"   then "version #{@params['order']}"
               end
        sort = "file_name asc" if sort == nil || sort == ""
        puts "sort = #{sort}"   
        puts "@params[:obj_type] = #{@params[:obj_type]} ; @params[:obj_id] = #{@params[:obj_id]}"    
        @docs = Document.find_by_sql "select doc1.*
                                      from documents as doc1
                                      left outer join documents as doc2 on doc2.file_name = doc1.file_name
                                      and doc2.version > doc1.version
                                      where doc2.version is null and doc1.obj_type = '#{@params[:obj_type]}' and doc1.obj_id = '#{@params[:obj_id]}'
                                      order by doc1.#{sort}"
        @params[:show_upload] = true
  #     @docs.each do |doc|
  #        puts "#{doc.file_name} - #{doc.version} - #{doc.author}"
  #      end  
     end
     if @params['column'] == 'authorName' 
        if @params[:order] == 'DESC'
          @docs = @docs.sort do |a,b| b.author.fname <=> a.author.fname end 
        end
        if @params[:order] == 'ASC'
          @docs = @docs.sort do |a,b| a.author.fname <=> b.author.fname end 
        end
      end
     
      if request.xml_http_request? && (@params['column'] != nil && @params['column'] != "") 
        puts "@params['column']  = .#{@params['column']}."
        render :partial => "list", :layout => false
      else 
          render :action => "list", :layout => false
       
      end
    end

    def delete
        @doc = Document.find(@params["id"])
       
        str = @doc.file_name;
        index = str.rindex(/[\.\s+]/)
        str[index]="_v#{@doc.version}."
        
        begin
            path = find_file(str, @doc.path)
           
            
            File.delete path
        rescue MissingFile => e
            flash['error'] = "Download error: #{e}" 
            redirect_to :action => 'list'
            return
        end
        
        Document.delete(@params["id"])
       
        @docs = Document.find_by_sql "select doc1.*
                                      from documents as doc1
                                      left outer join documents as doc2 on doc2.file_name = doc1.file_name
                                      and doc2.version > doc1.version
                                      where doc2.version is null 
                                      and doc1.obj_type='#{@doc.obj_type}'
                                      and doc1.obj_id='#{@doc.obj_id}'
                                      order by doc1.file_name asc"
        @params[:id] = nil
        @params[:obj_type] = @doc.obj_type
        @params[:obj_id] = @doc.obj_id
        render :partial => "list", :locals => {:docs => @docs}
    end
    
    
    protected
    # Safely resolve an absolute file path given a malicious filename.
    def find_file(filename, dir)
        path = File.expand_path("#{dir}#{File::SEPARATOR}#{filename}")
        puts "find_file : #{path}"
        # Deny ./../etc/passwd and friends.
        # File must exist, be readable, and not be a directory, pipe, etc.
        raise MissingFile, "couldn't read #{filename}" unless
            path =~ /^#{File.expand_path(dir)}/ and
            File.readable?(path) and
            File.file?(path)

        return path
    end
    def sanitize_filename(file_name)
      # get only the filename, not the whole path (from IE)
      just_filename = File.basename(file_name) 
      # replace all non-alphanumeric, underscore or periods with underscores
      just_filename.gsub(/[^\w\.\-]/,'_') 
    end
   
    public
    def create
      
      puts "document create begin #{@params['file']}"
      @doc = Document.new()
      @doc.file_name = sanitize_filename(@params['document']['file'].original_filename)
      puts  @session["user"].id
      @doc.author = @session["user"]
      @doc.obj_type = @params['document']['obj_type']
      @doc.obj_id = @params['document']['obj_id']
      
      @loadedDoc = Document.find(:first, 
        :conditions => ["obj_type=? and obj_id=? and file_name=?", @doc.obj_type, @doc.obj_id, @doc.file_name], :order => "version desc")
      if @loadedDoc != nil
        puts @loadedDoc
        puts "version = #{@loadedDoc.version}"
        @doc.version = @loadedDoc.version + 1
      end
      
      @doc.uploaded_file = @params['document']['file']
      if @doc.save
        flash['notice'] = 'Content was successfully created.'
        redirect_to :back
 
#        redirect_to :controller => @doc.obj_type, :action => "show", 'id' => @doc.obj_id, 'back' => @params[:back]
      else
        render_action 'new'
      end
    end


end