class TaskController < ApplicationController
    
    include ApplicationHelper
    auto_complete_for :task, :name
    auto_complete_for :project, :name
    
    def auto_complete_for_user_usr
        puts "in task_controller"
        @users = User.find_by_sql "select concat(fname,' ',lname) as usr 
                                   from users where LOWER(fname) LIKE '%#{@params[:user][:usr]}%' or 
                                   LOWER(lname) LIKE '%#{@params[:user][:usr]}%' 
                                   order by fname asc"
        render :inline => "<%= auto_complete_result(@users, 'usr') %>"
    end
    
    
    
    def new
        @task = Task.new
        @task.author = @session["user"]
        @task.owner = @session["user"]
        @task.startTime =  Date.today
        if @params[:project_id].nil?
            @task.project = Project.new
        else
            @task.project = Project.find(@params[:project_id])
        end
        puts "@params['owner'] = #{@params['owner']}"
        puts @task.project.name
        render_component :action => "show", :params => @params.merge({"new_task" => @task})
    end
    
    
    def save
        
        if @params[:task][:id].nil? || @params[:task][:id] == ""
            @task = Task.new
            @task.author =  @session["user"]
        else
            @task = Task.find(@params[:task][:id])
        end
        
        if @params[:task][:owner_id].nil?
            @ownerNames = params[:task][:owner].scan(/\w+/)
            @owner = User.find(:first, :conditions => [ "fname = ? AND lname =?", @ownerNames[0], @ownerNames[1]])
        else
            @owner = User.find(@params[:task][:owner_id])
        end
        @task.owner = @owner
        
        
        if params[:task][:endTime] == ""
            @task.endTime = 0
        else
            @task.endTime = dateDBFormat(params[:task][:endTime])
        end
        
        @task.startTime = dateDBFormat(params[:task][:startTime])  
        
        @task.name = params[:task][:name]
        @task.description = params[:task][:description]  
        
        if @params[:task][:project_id].nil? || @params[:task][:project_id] == ""
            @project = Project.find(:first, :conditions => ["name = ?", @params[:project][:name]]) 
        else
            @project = Project.find(@params[:task][:project_id])
        end
        @task.project = @project
        @task.parent_id = @params[:task][:parent_id]
        @task.save   
        
        if @task.errors.empty?
            puts "result is true"
            redirect_to "#{@params[:back]}"
        else
            @task.endTime = nil
            render :action => "show"
        end
#        puts "task is saved #{@task.name}"
#        puts "back : #{@params[:back]}"
#        redirect_to "#{@params[:back]}"
    end
    
    def list
        @tasks = find(@params, nil)
        
        if request.xml_http_request?
            render :partial => "list", :layout => false
        end
    end
    
    def taskForProject
        condition = ["project_id = ?  and parent_id is NULL", @params[:obj_id]] 
        
        @tasks = find(@params, condition)
        
        if request.xml_http_request?
            render :partial => "list", :layout => false
        end
    end
    
    def find (params, condition)
        
        puts "task_controller params #{params}"
        puts params['action']
        puts params['owner']
        
        
        sort = case params['column']
        when "name"  then "name #{params['order']}"
        when "startTime"   then "startTime #{params['order']}"
        when "endTime"   then "endTime #{@params['order']}"
        end
        
        puts sort
        puts "condition = #{condition}"
        puts defined? condition
        if condition == nil
            puts "condition is nil"
            if !params[:owner].nil?
                condition = ["owner_id = ?  and parent_id is NULL", "#{params[:owner]}"] 
            else
                condition = ["parent_id is NULL"] 
            end
        end
        
        @tasks = Task.find(:all, :order => sort, :conditions => condition)
        puts "the task are #{@tasks.size}"
        
        if params['column'] == 'projectName' 
            if params[:order] == 'DESC'
                @tasks = @tasks.sort do |a,b| b.project.name <=> a.project.name end 
            end
            if params[:order] == 'ASC'
                @tasks = @tasks.sort do |a,b| a.project.name <=> b.project.name end 
            end
        end
        
        if params['column'] == 'authorName' 
            if params[:order] == 'DESC'
                @tasks = @tasks.sort do |a,b| b.author.fname <=> a.author.fname end 
            end
            if params[:order] == 'ASC'
                @tasks = @tasks.sort do |a,b| a.author.fname <=> b.author.fname end 
            end
        end
        
        if params['column'] == 'ownerName' 
            if params[:order] == 'DESC'
                @tasks = @tasks.sort do |a,b| b.owner.fname <=> a.owner.fname end 
            end
            if params[:order] == 'ASC'
                @tasks = @tasks.sort do |a,b| a.owner.fname <=> b.owner.fname end 
            end
        end
        
        return @tasks
        
    end
    
    
    def show
        if params[:new_task] == nil
            @task = Task.find(params[:id])
        else
            @task = params[:new_task]
        end
        puts "task cont: #{@params['owner']}"
        #      puts "task cont: #{params['new_task'].project.name}"
        #      if params[:id] == nil
        #        @task = Task.new
        #        @task.owner = @session["user"]
        #        @task.author = @session["user"]
        #        @task.startTime = Date.today
        #        @task.project = Project.new
        #      else
        #        @task = Task.find(params[:id])
        #      end
        
        if request.xml_http_request?
            render :partial => "show", :layout => false
        end
    end
    
    def newTodo
        if @params[:id] != nil && @params[:id] != ""
            @task = Task.find(@params[:id])
            @parent = Task.find_by_id(@task[:parent_id])
        else
            @task = Task.new
            @task.author = @session["user"]
            @task.owner = @session["user"]
            @parent = Task.find_by_id(@params[:parent_id])
        end
    end
    
    def todoList
        @todosList = Task.find(:all, :order => "id DESC", :conditions => ["owner_id = ? and parent_id is null", @session["user"][:id]])
        puts @todosList.size
    end
    
    def showTodo
        puts "in showTodo : #{@params}"
        if @params[:id] == nil
            @parent = Task.find(:first, :conditions => ["owner_id = ?  and parent_id is NULL", @session["user"][:id]], :order => "id DESC")
            puts "here .......... id = #{@parent.id}"
        else
            @parent = Task.find_by_id(@params[:id])
        end
        conditions = ["owner_id = ? and parent_id = ?", @session["user"][:id], @parent.id]
        @tasks = find(@params, conditions)
        
        @finish = @tasks.find_all {|t| t.status == true}
        puts "the size is #{@finish.size}"
        puts "the size of all is #{@tasks.size}"
        if @tasks.size == 0
            @completed = 100
        else
            @completed = ((@finish.size) * 100) / (@tasks.size)
        end
        puts "@completed = #{@completed}"
        
        if request.xml_http_request?
            render :partial => "showTodo", :layout => !request.xml_http_request?
        end
    end
    
    
    
    def delete
        puts "Starting delete of task"
        puts params[:id]
        Task.delete(@params[:id])
        Task.delete_all "parent_id = #{@params[:id]}"
        if @params[:project] != nil
            puts "project is not null"
            puts @params[:project]
            @tasks =  Task.find(:all, :conditions => ["project_id = ? and parent_id is null", @params[:project]], :order => "id asc") 
            puts @tasks.size
        else
            puts "project is null"
            @tasks =  Task.find(:all, :conditions => ["parent_id is null"], :order => "id DESC")  
            puts @tasks.size
        end
        
        render :action => "list"
    end
    
    def update
        if @params[:changeStatus] != nil && request.xml_http_request?
            @parameters = @params[:changeStatus].split('_')
            puts "Starting update task with id #{@params[:changeStatus]}"
            if @parameters[1].to_s == 'true'
                puts "it is true"
                Task.update(@parameters[0], {"endTime" => Time.now, "status" => true})
            else
                Task.update(@parameters[0], {"endTime" => 0, "status" => false})
            end
            
            render_text @params[:changeStatus]
            
        end
        
    end 
end
