class UserController < ApplicationController
    auto_complete_for :user, :usr
    auto_complete_for :group, :name
    auto_complete_for :team, :name
    
    
    
    def list
        
        sort = case params['column']
        when "usr"  then "usr #{params['order']}"
        when "fname"   then "fname #{params['order']}"
        when "lname"   then "lname #{@params['order']}"
        end
        @users = User.find(:all, :order => sort)
        
        if params['column'] == 'groupName' 
            if params[:order] == 'DESC'
                @users = @users.sort do |a,b| b.group.name <=> a.group.name end 
            end
            if params[:order] == 'ASC'
                @users = @users.sort do |a,b| a.group.name <=> b.group.name end 
            end
        end
        if params['column'] == 'teamName' 
            if params[:order] == 'DESC'
                @users = @users.sort do |a,b| b.team.name <=> a.team.name end 
            end
            if params[:order] == 'ASC'
                @users = @users.sort do |a,b| a.team.name <=> b.team.name end 
            end
        end
        
        if request.xml_http_request?
            render :partial => "list", :layout => false
        end
    end
    
    def show
        if @params[:id] != nil && @params[:id] != ""
            @user = User.find(@params["id"]) 
        else
            @user = User.new
            @user.group = Group.new
        end
        puts "in controller #{@params['readonly']}"
    end
    
    def save
        if @params[:user][:id].nil? || @params[:user][:id] == ""
            @user = User.new() 
        else 
            @user = User.find(@params[:user][:id])
        end
        @user.attributes=@params[:user]
        
        if @params[:team][:name] != ""
            @team = Team.find_by_name(@params[:team][:name])
            @user.team_id = @team.id
#        else
#            @user.team = Team.new
        end
        
        @group = Group.find_by_name(@params[:group][:name])
        @user.group = @group 
        
        @user.save
        
        if @user.errors.empty?
            puts "result is true"
            redirect_to :action => "list"
        else
            puts "result is false"
            puts @params['readonly']
            render :action => "show", :params => {"readonly" => false}
        end
    end
    
    def delete
        @team = Team.find(:first, :conditions => ["leader_id = ?", @params[:id]])
        
        if @team != nil
            redirect_to :controller => "team", :action => "new", :id => @team.id, :back => "/user/list"
        else
            User.delete(@params[:id])
            redirect_to :action => "list"
        end
       
    end
    
    def update_group
        if @params[:user][:usr].nil?
            @userNames = params[:task][:owner].scan(/\w+/)
            @user = User.find(:first, :conditions => [ "fname = ? AND lname =?", @ownerNames[0], @ownerNames[1]])
        else
            
        end
        @group = Group.find_by_name(@params[:group])
        @user.group = @group
        
        @user.save
        
        if !@user.errors.empty?
            render :text => "the user is not correct", :status => 404
        end
    end
end
