class Document < ActiveRecord::Base
    require 'ftools'
    belongs_to :author, :class_name => "User", :foreign_key => "author_id"
 
    
    def uploaded_file=(incoming_file)
      puts "incoming file = #{incoming_file} #{incoming_file.original_filename} #{incoming_file.content_type}"
      self.name = incoming_file.original_filename
      self.content_type = incoming_file.content_type
      @temp_file = incoming_file
    end
  
    def before_save
       puts "@doc = #{@doc}"
    end
    
    def after_save
      str = self.file_name;
      index = str.rindex(/[\.\s+]/)
      str[index]="_v#{self.version}."
     
      if @temp_file
        File.makedirs path
        puts "--> #{@path}#{File::SEPARATOR}#{str}"
        File.open("#{@path}#{File::SEPARATOR}#{str}", "wb") do |f| 
          f.write(@temp_file.read)
        end
      end
    end
    
    
    
    def path
      @path = "#{RAILS_ROOT}#{File::SEPARATOR}files#{File::SEPARATOR}#{self.obj_type}#{File::SEPARATOR}#{self.obj_id}"
    end
    
    def name=(new_file_name)
      write_attribute("file_name", sanitize_filename(new_file_name))
    end
  
     def content_type=(type)
      puts "name = #{type}"
      write_attribute("content_type", type)
    end
   private
  
    def sanitize_filename(file_name)
      # get only the filename, not the whole path (from IE)
      just_filename = File.basename(file_name) 
      # replace all non-alphanumeric, underscore or periods with underscores
      just_filename.gsub(/[^\w\.\-]/,'_') 
    end
end
