class Task < ActiveRecord::Base
    belongs_to :project
    belongs_to :owner, :class_name => "User", :foreign_key => "owner_id"
    belongs_to :author, :class_name => "User", :foreign_key => "author_id"
    
    def validate
        errors.add_on_empty %w( name startTime)
        
        errors.add("project", "the project does not exist") if project.nil?
        errors.add("author", "the author does not exist") if author.nil?
        errors.add("owner", "the owner does not exist") if owner.nil?
        
        if project != nil
            @tasks = Task.find(:all, :conditions => ["name = ? and project_id = ?", name, project.id])
#            puts "@tasks = #{@tasks.size} "
#            puts "#{!id.nil?}  >#{id}<  #{@tasks[0].id} "
#            puts "#{!id.nil?}  >#{id != ""}<  #{@tasks[0].id!= id} "
            if @tasks.length >= 1
                if (!id.nil? || id != "") && @tasks[0].id != id
                    puts "duplicate name"
                    errors.add("name", "the task name  exist in this project")
                end
            end
        end
        
        if endTime != nil && endTime != 0
#            puts "validate: #{endTime}"
            errors.add("endTime", "the end date should be after start date") if endTime < startTime
        end
    end
end
