class Team < ActiveRecord::Base
    has_many :user
    has_many :project
    belongs_to :teamLeader, :class_name => "User", :foreign_key => "leader_id"
    
    def validate
        errors.add_on_empty %w( name )
        
        errors.add("teamLeader", "the team leader does not exist") if teamLeader.nil?
        
        @teams = Team.find(:all, :conditions => ["name = ?", name])
        
        if @teams.size >= 1
            if (!id.nil? || id != "") && @teams[0].id != id
                errors.add("name", "duplicate name")
            end
        end
    end
end
